﻿Imports System.Text.Encoding
Imports System.Text.RegularExpressions

Public Class Form1

  Private irc As libircc.libircc
  Private WithEvents t As Timer

  Public Sub New()
    InitializeComponent()
    Me.txtURI.Text = "irc://libirc" & Process.GetCurrentProcess().Id().ToString() & "@irc.livedoor.ne.jp:6665/#libirc"
  End Sub

  ' 接続ボタン
  Private Sub Connect(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkConnect.CheckedChanged
    If CType(sender, CheckBox).Checked Then
      ' ON
      Dim Nick As String = Regex.Match(txtURI.Text, "(?<=irc://)[a-zA-Z0-9_]+(?=[:@])").Value
      Dim Pass As String = Regex.Match(txtURI.Text, "(?<=irc://[a-zA-Z0-9_]+:)[a-zA-Z0-9_]+(?=@)").Value
      Dim Server As String = Regex.Match(txtURI.Text, "(?<=irc://[a-zA-Z0-9_:]+@)[^:/]+").Value
      Dim Port As String = Regex.Match(txtURI.Text, "(?<=irc://[a-zA-Z0-9_:]+@[^:/]+:)[0-9]+").Value
      Dim Channel As String = Regex.Match(txtURI.Text, "(?<=irc://[a-zA-Z0-9_:@\.\-]+?/).*").Value
      Dim Charset As System.Text.Encoding = GetEncoding(50220) ' ISO-2022-JP(JISコード)。UTF-8 の場合は Encoding.UTF8 を指定。
      If Port.Length = 0 Then Port = 6666
      If Nick.Length > 0 And Server.Length > 0 Then
        irc = New libircc.libircc(Server, Port, Pass, Charset, Nick, Nick, "libircc User")
        t = New Timer
        t.Interval = 15
        t.Start()
        If Channel.Length > 0 Then
          ' 本当は MOTD の受信が終わるまで待機してから Join する方が良い。
          irc.join(Channel)
        End If
      End If
    Else
      ' OFF
      If Not irc Is Nothing Then
        t.Stop()
        irc.Dispose()
        irc = Nothing
      End If
    End If
  End Sub

  ' Enter キーが押された際にコマンドを送信する。
  Private Sub SendMessage(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtCommand.KeyDown
    If irc Is Nothing Then Exit Sub
    If e.KeyCode = Keys.Enter And txtCommand.Text.Length > 0 Then
      irc.Message = txtCommand.Text
      txtCommand.Text = String.Empty
    End If
  End Sub

  ' 定期的に、到着したメッセージがないか調べて、
  ' あればそれを表示する。
  Private Sub CheckMessage() Handles t.Tick
    While True
      Dim msg As String = irc.Message
      If msg.Length < 1 Then Exit While
      log.Text &= Replace(msg, vbNewLine, String.Empty) & vbNewLine
      If log.TextLength > 100 Then log.Lines(0).Remove(0)
      log.SelectionStart = log.TextLength : log.Focus() : log.ScrollToCaret()
      txtCommand.Focus()
    End While
  End Sub

End Class
